/*      Copyright 1998-2002 SourceGear Corporation.
        All Rights Reserved. */

#ifndef CLCRYPTO_H
#define CLCRYPTO_H

#ifndef BUILD_STANDARD

#include "CLcommon.h"

void InitCrypto(TimeStamps *pTimeStamps);
int GetUserKey(RequestInfo *pReqInfo);
BF_KEY* SetKey(unsigned char* key, int nKeyLength);
void Decrypt(char* in, char* out, int size, BF_KEY* pKey, char* IV);
DArray* Encrypt(char* pStrData, int nLength, BF_KEY *pKey, unsigned char* IV);
void GetRandomNumber(unsigned char *number, int nLength);


/* String representation of key file header names */
#define KH_USERNAME		"Username"
#define KH_SERVER		"Server"
#define KH_KEY_FORMAT	"Key-Format"
#define KH_EXPIRES		"Expires"
#define KH_KEY			"Key"
#define KH_HASH			"Hash"

#define KEY_FORMAT	1
#define PAD_CHAR ' '

#define CRYPTO_BLOCK_SIZE	8		/*  8 bytes */
#define CRYPTO_HEADER_SIZE			24
#define CRYPTO_HEADER_IV_SIZE		8
#define CRYPTO_HEADER_LENGTH_SIZE	16

#endif /* !BUILD_STANDARD */

#endif /* VERMCRYPTO_H */
