#ifndef CLNET_H
#define CLNET_H


/*******************************************************

	FILE: CLnet.h

	DESC: This file contains declarations for Network
		related functions .
 
        Copyright 1998-2002 SourceGear Corporation.
        All Rights Reserved. 

*******************************************************/

/* open connection and return socket */
int Net_ConnectToServer(char *szServer, int nPort);

/* close connection */
void Net_CloseServerConnection (int theSocket, RequestInfo *pReqInfo) ;


/* Get an entire response message from an open socket */
int Net_GetEntireResponse(int nSocket, MessageInfo *pMsgInfo, RequestInfo *pReqInfo);

/* Get a response message from an open socket, sending body to a file */
int Net_GetResponse(int	nInSocket, MessageInfo *pOutMsgInfo, RequestInfo *pReqInfo,
	char *szFileName, char *szWorkingDir, int bOverride);

/* Send an entire request message to an open socket */
int Net_SendRequest(int nInSocket, MessageInfo *pMsgInfo, RequestInfo *pReqInfo) ;

/*	Send a request message to an open socket, appending the file
	specified in the message to the message body */
int Net_SendRequestAppendFile(int nInSocket, MessageInfo *pMsgInfo,
							  char *szFileName, char *szWorkDir, RequestInfo *pReqInfo) ;




#endif /* CLNET_H */
