#ifndef PARAMS_H
#define PARAMS_H

/*******************************************************

	FILE: CLparams.h

	DESC: This file contains declarations for functions 
		that parse and verify input parameters.
 
        Copyright 1998-2002 SourceGear Corporation.
        All Rights Reserved. 

*******************************************************/


/* Command line parameter names */
#define P_COMMAND		"-command"
#define P_SERVER		"-server"
#define P_DATABASE		"-database"
#define P_NAME			"-name"
#define P_PASSWORD		"-password"
#define P_PROJECT		"-project"
#define P_FILE			"-file"
#define P_REVISION		"-revision"
#define P_VERBOSE		"-verbose"
#define P_RECURSIVE		"-recursive"
#define P_LOG			"-log"
#define P_WORKDIR		"-workdir"
#define P_LABEL			"-label"
#define P_PERMANENT		"-permanent"
#define P_NEWNAME		"-newname"
#define P_SOSHOME		"-soshome"
#define P_NOCOMPRESS	"-nocompression"
#define P_ALWAYSDOWNLOAD "-nocache"
#define P_WRITEABLE		"-writeable"
#define P_SHARETO		"-shareto"
#define P_BRANCH		"-branch"

#define CMD_PREFIX '-'

#define ROOT_PROJECT	"$/"

/* Function prototypes */

/*	Parse all the input parameters, and place
	individual parameters into a RequestInfo Structure */
void ParseParameters(int argc, 
					 char *argv[], 
					 RequestInfo* pOutReqInfo);


/*	Verify that all the parameters for a given request
	are present and valid */
int VerifyRequestParams(RequestInfo* pReqInfo);


/* Initialze a RequestInfo struct to default values */
void RI_Initialize(RequestInfo *pReqInfo);


#endif /* PARAMS_H */

