/*      Copyright 1998-2002 SourceGear Corporation.
        All Rights Reserved. */

#include <gtk/gtk.h>

#include "Vermie.h"
#include "CheckinDlg.h"
#include "VermFrameWnd.h"

static void diff_clicked(GtkWidget*, CCheckinDlg* pDlg)
{
	pDlg->m_pParent->OnToolsShowDifferences();
}

CCheckinDlg::CCheckinDlg(CVermFrameWnd* pParent, int bDiff) : CVermDlg("Checkin Files", MB_OK|MB_CANCEL)
{
  GtkWidget *dialog_vbox1;
  GtkWidget *table1;
  GtkWidget *label1;
  GtkWidget *dialog_action_area1;

  m_pParent = pParent;
  
  dialog_vbox1 = GTK_DIALOG (m_pDialog)->vbox;
  gtk_object_set_data (GTK_OBJECT (m_pDialog), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  dialog_vbox1 = GTK_DIALOG (m_pDialog)->vbox;
  gtk_object_set_data (GTK_OBJECT (m_pDialog), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  table1 = gtk_table_new (5, 1, FALSE);
  gtk_object_set_data (GTK_OBJECT (m_pDialog), "table1", table1);
  gtk_widget_show (table1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), table1, TRUE, TRUE, 0);

  label1 = gtk_label_new ("Comment:");
  gtk_object_set_data (GTK_OBJECT (m_pDialog), "label1", label1);
  gtk_widget_show (label1);
  gtk_table_attach (GTK_TABLE (table1), label1, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 5, 5);
  gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label1), 1.93715e-07, 0.5);

  comment = gtk_text_new ((GtkAdjustment*)NULL, (GtkAdjustment*)NULL);
  gtk_object_set_data (GTK_OBJECT (m_pDialog), "comment", comment);
  gtk_widget_show (comment);
  gtk_widget_set_usize(comment, 300, 100);
  gtk_text_set_word_wrap(GTK_TEXT(comment), 0);
  
  gtk_table_attach (GTK_TABLE (table1), comment, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 5, 6);
  gtk_text_set_editable (GTK_TEXT (comment), TRUE);

  int r1 = 2, r2 = 3;
  
  if (bDiff)
  {
	  diff = gtk_button_new_with_label("Diff");
	  gtk_signal_connect(GTK_OBJECT(diff), "clicked",
						 GTK_SIGNAL_FUNC(diff_clicked), this);
	  
	  gtk_widget_show(diff);
	  
	  gtk_table_attach(GTK_TABLE(table1), diff, 0, 1, r1, r2, 
                    (GtkAttachOptions) 0, (GtkAttachOptions) GTK_FILL, 5, 6);

	  r1++;
	  r2++;
  }
  
  keepCheckedOut = gtk_check_button_new_with_label ("Keep Checked Out");
  gtk_object_set_data (GTK_OBJECT (m_pDialog), "keepCheckedOut", keepCheckedOut);
  gtk_widget_show (keepCheckedOut);
  gtk_table_attach (GTK_TABLE (table1), keepCheckedOut, 0, 1, r1, r2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), (GtkAttachOptions) 0, 5, 5);

  r1++;
  r2++;
  
  removeLocalCopy = gtk_check_button_new_with_label ("Remove Local Copy");
  gtk_object_set_data (GTK_OBJECT (m_pDialog), "removeLocalCopy", removeLocalCopy);
  gtk_widget_show (removeLocalCopy);
  gtk_table_attach (GTK_TABLE (table1), removeLocalCopy, 0, 1, r1, r2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), (GtkAttachOptions) 0, 5, 0);

  r1++;
  r2++;
  
  recursive = gtk_check_button_new_with_label ("Recursive");
  gtk_object_set_data (GTK_OBJECT (m_pDialog), "recursive", recursive);
  gtk_widget_show (recursive);
  gtk_table_attach (GTK_TABLE (table1), recursive, 0, 1, r1, r2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), (GtkAttachOptions) 0, 5, 5);

  dialog_action_area1 = GTK_DIALOG (m_pDialog)->action_area;
  gtk_object_set_data (GTK_OBJECT (m_pDialog), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_border_width (GTK_CONTAINER (dialog_action_area1), 10);
}

CCheckinDlg::~CCheckinDlg()
{
	gtk_widget_destroy(m_pDialog);
}
