/*      Copyright 1998-2002 SourceGear Corporation.
        All Rights Reserved. */

#include "Vermie.h"
#include "LoginDlg.h"

static void enter_callback( GtkWidget *widget, CLoginDlg *entry );

static void enter_callback( GtkWidget *widget, CLoginDlg* pDlg )
{
	pDlg->OnOK();
}

CLoginDlg::CLoginDlg(const char* title, Databases* databases, int numDatabases, String* strUsername) : CVermDlg(title, MB_OK | MB_CANCEL)
{
//  gtk_object_set_data (GTK_OBJECT (m_pDialog), "m_pDialog", m_pDialog);
  gtk_window_set_policy (GTK_WINDOW (m_pDialog), TRUE, TRUE, FALSE);

  dialog_vbox1 = GTK_DIALOG (m_pDialog)->vbox;
  gtk_object_set_data (GTK_OBJECT (m_pDialog), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  table1 = gtk_table_new (3, 2, FALSE);
  gtk_object_set_data (GTK_OBJECT (m_pDialog), "table1", table1);
  gtk_widget_show (table1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), table1, TRUE, TRUE, 0);
  gtk_container_border_width (GTK_CONTAINER (table1), 10);

  database = gtk_combo_new ();
  gtk_object_set_data (GTK_OBJECT (m_pDialog), "database", database);

  GList* list = NULL;

  int selPos = 0;

  for (int i = 0; i < numDatabases; i++)
  {
	  list = g_list_append(list, (void*)databases[i].strAlias.chars());

	  if (databases[i].strDatabase == Vermie::m_strDatabaseName)
		  selPos = i;
  }

  gtk_combo_set_popdown_strings(GTK_COMBO(database), list);
  gtk_widget_show (database);
  gtk_table_attach (GTK_TABLE (table1), database, 1, 2, 2, 3,
                    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
					(GtkAttachOptions)0, 5, 5);

  g_list_free(list);
  
  gtk_list_select_item(GTK_LIST(GTK_COMBO(database)->list), selPos);
  
  label3 = gtk_label_new ("Database:");
  gtk_object_set_data (GTK_OBJECT (m_pDialog), "label3", label3);
  gtk_widget_show (label3);
  gtk_table_attach (GTK_TABLE (table1), label3, 0, 1, 2, 3,
                    (GtkAttachOptions)0, (GtkAttachOptions)0, 5, 5);
  gtk_label_set_justify (GTK_LABEL (label3), GTK_JUSTIFY_RIGHT);

  password = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (m_pDialog), "password", password);
  gtk_entry_set_visibility(GTK_ENTRY(password), FALSE);
  gtk_widget_show (password);
  gtk_signal_connect(GTK_OBJECT(password), "activate",
					 GTK_SIGNAL_FUNC(enter_callback),
					 this);
  
  gtk_table_attach (GTK_TABLE (table1), password, 1, 2, 1, 2,
                    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
					(GtkAttachOptions)0, 5, 5);
  
  gtk_widget_grab_focus(password);
  gtk_grab_add(m_pDialog);
  
  label1 = gtk_label_new ("Username:");
  gtk_object_set_data (GTK_OBJECT (m_pDialog), "label1", label1);
  gtk_widget_show (label1);
  gtk_table_attach (GTK_TABLE (table1), label1, 0, 1, 0, 1,
                    (GtkAttachOptions)0, (GtkAttachOptions)0, 5, 5);
  gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_RIGHT);

  label2 = gtk_label_new ("Password:");
  gtk_object_set_data (GTK_OBJECT (m_pDialog), "label2", label2);
  gtk_widget_show (label2);
  gtk_table_attach (GTK_TABLE (table1), label2, 0, 1, 1, 2,
                    (GtkAttachOptions)0, (GtkAttachOptions)0, 5, 5);
  gtk_label_set_justify (GTK_LABEL (label2), GTK_JUSTIFY_RIGHT);

  username = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (m_pDialog), "username", username);

  if (!Vermie::m_strUserName.empty())
  {
	  gtk_entry_set_text(GTK_ENTRY(username), Vermie::m_strUserName.chars());
  }
  else
  {
	  gtk_widget_grab_focus(username);
  }
  
  gtk_widget_show (username);

  gtk_signal_connect(GTK_OBJECT(username), "activate",
					 GTK_SIGNAL_FUNC(enter_callback),
					 this);
  
  gtk_table_attach (GTK_TABLE (table1), username, 1, 2, 0, 1,
                    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
					(GtkAttachOptions)0, 5, 5);

  if (!strUsername->empty())
	  gtk_entry_set_text(GTK_ENTRY(username), strUsername->chars());
  
  dialog_action_area1 = GTK_DIALOG (m_pDialog)->action_area;
  gtk_object_set_data (GTK_OBJECT (m_pDialog), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_border_width (GTK_CONTAINER (dialog_action_area1), 10);
}

CLoginDlg::~CLoginDlg()
{
	gtk_widget_destroy(m_pDialog);
}
