/*      Copyright 1998-2002 SourceGear Corporation.
        All Rights Reserved. */

#include <gtk/gtk.h>

#include "PasswordDlg.h"

static void enter_callback(GtkWidget*, CPasswordDlg* pDlg)
{
	pDlg->OnOK();
}

CPasswordDlg::CPasswordDlg(void) : CVermDlg("Change Password", MB_OK | MB_CANCEL)
{
  GtkWidget* vb1 = GTK_DIALOG (m_pDialog)->vbox;
  gtk_widget_show (vb1);

  GtkWidget* hb1 = gtk_hbox_new(FALSE, 0);
  gtk_widget_show(hb1);
  gtk_box_pack_start(GTK_BOX(vb1), hb1, TRUE, TRUE, 0);
  
  GtkWidget* l1 = gtk_label_new("Old Password:");
  gtk_widget_show(l1);
  gtk_box_pack_start(GTK_BOX(hb1), l1, TRUE, TRUE, 0);
  
  oldPassword = gtk_entry_new();
  gtk_widget_show(oldPassword);
  gtk_entry_set_visibility(GTK_ENTRY(oldPassword), FALSE);
  gtk_signal_connect(GTK_OBJECT(oldPassword), "activate",
					 GTK_SIGNAL_FUNC(enter_callback),
					 this);
  gtk_box_pack_start(GTK_BOX(hb1), oldPassword, TRUE, TRUE, 0);

  GtkWidget* hb2 = gtk_hbox_new(FALSE, 0);
  gtk_widget_show(hb2);
  gtk_box_pack_start(GTK_BOX(vb1), hb2, TRUE, TRUE, 0);
  
  GtkWidget* l2 = gtk_label_new("New Password:");
  gtk_widget_show(l2);
  gtk_box_pack_start(GTK_BOX(hb2), l2, TRUE, TRUE, 0);
  
  newPassword = gtk_entry_new();
  gtk_widget_show(newPassword);
  gtk_entry_set_visibility(GTK_ENTRY(newPassword), FALSE);
  gtk_signal_connect(GTK_OBJECT(newPassword), "activate",
					 GTK_SIGNAL_FUNC(enter_callback),
					 this);
  gtk_box_pack_start(GTK_BOX(hb2), newPassword, TRUE, TRUE, 0);

  GtkWidget* hb3 = gtk_hbox_new(FALSE, 0);
  gtk_widget_show(hb3);
  gtk_box_pack_start(GTK_BOX(vb1), hb3, TRUE, TRUE, 0);
  
  GtkWidget* l3 = gtk_label_new("New Password:");
  gtk_widget_show(l3);
  gtk_box_pack_start(GTK_BOX(hb3), l3, TRUE, TRUE, 0);
  
  newPasswordRepeat = gtk_entry_new();
  gtk_widget_show(newPasswordRepeat);
  gtk_entry_set_visibility(GTK_ENTRY(newPasswordRepeat), FALSE);

  gtk_signal_connect(GTK_OBJECT(newPasswordRepeat), "activate",
					 GTK_SIGNAL_FUNC(enter_callback),
					 this);

  gtk_box_pack_start(GTK_BOX(hb3), newPasswordRepeat, TRUE, TRUE, 0);
}

CPasswordDlg::~CPasswordDlg(void)
{
	gtk_widget_destroy(m_pDialog);
}
