/*      Copyright 1998-2002 SourceGear Corporation.
        All Rights Reserved. */

#include "Vermie.h"
#include "String.h"
#include "ServerDlg.h"

static void enter_callback( GtkWidget *widget, CServerDlg *entry );

static void enter_callback( GtkWidget *widget, CServerDlg* pDlg )
{
	pDlg->OnOK();
}

CServerDlg::CServerDlg(char* szTitle, int style) : CVermDlg(szTitle, style)
{
	String serverList = Vermie::m_strServerList;
	String portList = Vermie::m_strPortList;
	
	dialog_vbox2 = GTK_DIALOG (m_pDialog)->vbox;
	gtk_object_set_data (GTK_OBJECT (m_pDialog), "dialog_vbox2", dialog_vbox2);
	gtk_widget_show (dialog_vbox2);

	table2 = gtk_table_new (2, 2, FALSE);
	gtk_object_set_data (GTK_OBJECT (m_pDialog), "table2", table2);
	gtk_widget_show (table2);
	gtk_box_pack_start (GTK_BOX (dialog_vbox2), table2, TRUE, TRUE, 0);

	GList *glist = NULL;

	if (!portList.empty())
	{
		int pos = portList.index(';');

		while (pos > 0)
		{
			String p = portList.before(pos);
			char* chars = new char[p.length() + 1];

			strcpy(chars, p.chars());
			
			portList = portList.after(pos);

			glist = g_list_append(glist, (void*)chars);

			pos = portList.index(';');
		}

		if (!portList.empty())
		{
			char* chars = new char[portList.length() + 1];

			strcpy(chars, portList.chars());
			glist = g_list_append(glist, (void*)chars);
		}
	}

	port = gtk_combo_new ();
	gtk_object_set_data (GTK_OBJECT (m_pDialog), "port", port);
	gtk_widget_show (port);
	gtk_signal_connect(GTK_OBJECT(GTK_COMBO(port)->entry), "activate",
					 GTK_SIGNAL_FUNC(enter_callback),
					 this);

	if (glist)
	{
		gtk_combo_set_popdown_strings(GTK_COMBO(port), glist);
		g_list_free(glist);
		glist = NULL;
	}

	if (!Vermie::m_strLastPort.empty())
		gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(port)->entry), Vermie::m_strLastPort.chars());

	gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(port)->entry), TRUE);
	gtk_table_attach (GTK_TABLE (table2), port, 1, 2, 1, 2,
					  (GtkAttachOptions)0, (GtkAttachOptions)0, 5, 5);

	if (!serverList.empty())
	{
		int pos = serverList.index(';');

		while (pos > 0)
		{
			String ser = serverList.before(pos);
			char* chars = new char[ser.length() + 1];
			strcpy(chars, ser.chars());
			
			serverList = serverList.after(pos);

			glist = g_list_append(glist, (void*)chars);

			pos = serverList.index(';');
		}

		if (!serverList.empty())
		{
			char* chars = new char[serverList.length() + 1];
			strcpy(chars, serverList.chars());
			glist = g_list_append(glist, (void*)chars);
		}
	}
	
	server = gtk_combo_new ();
	gtk_object_set_data (GTK_OBJECT (m_pDialog), "server", server);

	if (glist)
	{
		gtk_combo_set_popdown_strings(GTK_COMBO(server), glist);
		g_list_free(glist);
		glist = NULL;
	}
	
	gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(server)->entry), TRUE);
	gtk_widget_show (server);
	gtk_signal_connect(GTK_OBJECT(GTK_COMBO(server)->entry), "activate",
					 GTK_SIGNAL_FUNC(enter_callback),
					 this);

	if (!Vermie::m_strLastServer.empty())
		gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(server)->entry), Vermie::m_strLastServer.chars());
	
	gtk_table_attach (GTK_TABLE (table2), server, 1, 2, 0, 1,
					  (GtkAttachOptions)0, (GtkAttachOptions)0, 5, 5);

	label3 = gtk_label_new ("Port:");
	gtk_object_set_data (GTK_OBJECT (m_pDialog), "label3", label3);
	gtk_widget_show (label3);
	gtk_table_attach (GTK_TABLE (table2), label3, 0, 1, 1, 2,
					  (GtkAttachOptions)0, (GtkAttachOptions)0, 5, 5);
	gtk_label_set_justify (GTK_LABEL (label3), GTK_JUSTIFY_RIGHT);

	label2 = gtk_label_new ("Server:");
	gtk_object_set_data (GTK_OBJECT (m_pDialog), "label2", label2);
	gtk_widget_show (label2);
	gtk_table_attach (GTK_TABLE (table2), label2, 0, 1, 0, 1,
					  (GtkAttachOptions)0, (GtkAttachOptions)0, 5, 5);
	gtk_label_set_justify (GTK_LABEL (label2), GTK_JUSTIFY_RIGHT);

	dialog_action_area2 = GTK_DIALOG (m_pDialog)->action_area;
	gtk_object_set_data (GTK_OBJECT (m_pDialog), "dialog_action_area2", dialog_action_area2);
	gtk_widget_show (dialog_action_area2);
	gtk_container_border_width (GTK_CONTAINER (dialog_action_area2), 10);
}

CServerDlg::~CServerDlg()
{
	gtk_widget_destroy(m_pDialog);
}
