/*      Copyright 1998-2002 SourceGear Corporation.
        All Rights Reserved. */

#include "String.h"

String::String()
{
	str = "";
}

String::String(const String& s)
{
	str = s.str;
}

String::String(const char* s)
{
	str = s;
}


String::String(const char* s, int l)
{
	str = "";
  
	str.append(s, l);
}

String::~String()
{
}

int String::ReverseFind(char c)
{
	return str.rfind(c);
}

int String::empty(void)
{
	return str.empty();
}

int String::contains(String& s)
{
	return str.find(s.chars()) ? 1 : 0;
}

String String::substr(int beg, int len)
{
	std::string s = str.substr(beg, len);
	return String(s.c_str());
}

String String::after(int pos)
{
	std::string s = str.substr(pos + 1);
	return String(s.c_str());
}

String String::before(int pos)
{
	std::string s = str.substr(0, pos);
	return String(s.c_str());
}

void String::del(int s, int e)
{
	str.erase(s, e);
}

int String::length()
{
	return str.length();
}

int String::index(char c)
{
	return str.find(c);
}

int String::index(char* s)
{
	return str.find(s);
}

char* String::chars()
{
	return (char*)str.c_str();
}

void String::downcase()
{
	int len = str.length();

	for (int i = 0; i < len; i++)
		if (str[i] >= 'A' && str[i] <= 'Z')
			str[i] += 32;
}

void String::upcase()
{
	int len = str.length();

	for (int i = 0; i < len; i++)
		if (str[i] >= 'a' && str[i] <= 'z')
			str[i] -= 32;
}
  
String String::operator +(char* s)
{
	std::string s2 = str + s;
	String ret(s2.c_str());

	return ret;
}

String String::operator +(String& s)
{
	std::string s2 = str + s.chars();

	String ret(s2.c_str());
  
	return ret;
}

String& String::operator =(char* s)
{
	if (s == NULL)
		str = "";
	else
		str = s;
  
	return *this;
}

String& String::operator +=(char* s)
{
	str += s;
	return *this;
}

String& String::operator +=(const String& s)
{
	str += ((String)(s)).chars();
	return *this;
}

String& String::operator +=(char c)
{
	str += c;
	return *this;
}

int String::operator !=(String& s)
{
	if (s == NULL)
		return 0;

	return str != s.chars();
}

int String::operator !=(char* s)
{
	if (!s)
		return 0;

	return str != s;
}

int String::operator ==(char* s)
{
	if (!s)
		return 0;
	
	return str == s;
}

int String::operator ==(const String& s)
{
	return str == ((String)(s)).chars();
}

char String::operator [](int p)
{
	return str[p];
}

String operator +(char* s1, String& s2)
{
	String s3 = s1;
	s3 += s2;

	return s3;
}
  

int fcompare(const String& s1, const String& s2)
{
	return strcasecmp(((String)(s1)).chars(), ((String)(s2)).chars());
}

int fcompare(const String& s1, const char* s2)
{
	return strcasecmp(((String)(s1)).chars(), s2);
}

String reverse(String& s)
{
	String ret;

	int i;
	int len = s.length();
  
	for (i = len -1 ; i >= 0; i--)
    {
		ret += s[i];
    }

	return ret;
}
