/*      Copyright 1998-2002 SourceGear Corporation.
        All Rights Reserved. */

#ifndef STRING_H
#define STRING_H

#include <string>

class String
{
 public:
  std::string str;

 public:
  String();
  String(const String&);
  String(const char*);
  String(const char*, int);
  ~String();
  
  int empty();
  String after(int);
  String before(int);
  int index(char);
  int index(char*);
  char* chars();
  int length();
  void downcase();
  void upcase();
  void del(int, int);
  int contains(String&);
  int ReverseFind(char);
  String substr(int, int);
  String operator +(char*);
  String operator +(String&);
  String& operator =(char*);
  String& operator +=(char*);
  String& operator +=(const String&);
  String& operator +=(char);

  int operator !=(String&);
  int operator !=(char*);
  int operator ==(char*);
  int operator ==(const String&);
  char operator [](int);

  friend String operator +(char*, String&);
  
};

int fcompare(const String&, const String&);
int fcompare(const String& s1, const char* s2);
String reverse(String&);

#endif // STRING_H
