/*      Copyright 1998-2002 SourceGear Corporation.
        All Rights Reserved. */

#ifndef VERMBYTEQUEUE_H
#define VERMBYTEQUEUE_H

#include "String.h"

class VermByteList
{
 public:
	char*         m_pBytes;
	int           m_nLen;
	int           m_nAllocLen;
	VermByteList* m_pNext;

	VermByteList(char* bytes, int len, int allocLen = 0);
	~VermByteList();

	void AddBytes(char* bytes, int len);
};

class VermByteQueue
{
 public:
	VermByteList* m_pHead;
	VermByteList* m_pTail;

	VermByteQueue();
	~VermByteQueue();

	void AddBytes(char* bytes, int len);
	int GetBytes(char**);
    void RemoveBytes(int len);

	VermByteQueue& operator+=(const String&);
	VermByteQueue& operator+=(const VermByteQueue&);
};

#endif VERMBYTEQUEUE_H
