/*      Copyright 1998-2002 SourceGear Corporation.
        All Rights Reserved. */

#ifndef BUILD_STANDARD

#ifndef VERMCRYPTO_H
#define VERMCRYPTO_H

#include <String.h>

#include "VermByteQueue.h"

extern "C"
{
#include "blowfish.h"
#include "rand.h"
}

#define CRYPTO_BLOCK_SIZE	8		//  8 bytes

#define CRYPTO_HEADER_SIZE			24
#define CRYPTO_HEADER_IV_SIZE		8
#define CRYPTO_HEADER_LENGTH_SIZE	16

#define KEY_FORMAT	1

#define KEY_HEADER_USERNAME		"Username"
#define KEY_HEADER_SERVER		"Server"
#define KEY_HEADER_KEY			"Key"
#define KEY_HEADER_HASH			"Hash"
#define KEY_HEADER_EXPIRES		"Expires"
#define KEY_HEADER_FORMAT		"Key-Format"

#define PAD_CHAR ' '

class CVermProtocolMessage;

class CVermCrypto
{
private:
	BF_KEY*	m_pKey;

	randctx m_CTX;

	int m_bCtxInitialized;

public:
	int m_nKeyLength;
	
	CVermCrypto();
	virtual ~CVermCrypto();
	
	int GetUserKey(const char* user, const char* server, char** key);
	CVermProtocolMessage* DecryptKey(char* digest, char* pFileData, int nDataSize, int keyLength);

	void GetRandomNumber(char *number, int nLength);

	int SetKey(char *key);

	void Decrypt(char* in, char* out, int size, char* IV);

	VermByteQueue* Encrypt(String* pStrData, char* IV);
	VermByteQueue* Encrypt(VermByteQueue* pQueue, char* IV);
};

#endif /* VERMCRYPTO_H */

#endif // !BUILD_STANDARD
