/*      Copyright 1998-2002 SourceGear Corporation.
        All Rights Reserved. */

#include "VermDlg.h"
#include "Vermie.h"

static int whichPressed = 0;

static void DlgDestroy(GtkWidget*, gpointer)
{
	whichPressed = IDCANCEL;
}

static void ok_clicked(GtkWidget*, CVermDlg* pDlg)
{
	pDlg->OnOK();
}

static void yes_clicked(GtkWidget*, gpointer)
{
	whichPressed = IDYES;
	gtk_main_quit();
}

static void yestoall_clicked(GtkWidget*, gpointer)
{
	whichPressed = IDYESTOALL;
	gtk_main_quit();
}

static void no_clicked(GtkWidget*, gpointer)
{
	whichPressed = IDNO;
	gtk_main_quit();
}

static void notoall_clicked(GtkWidget*, gpointer)
{
	whichPressed = IDNOTOALL;
	gtk_main_quit();
}

static void cancel_clicked(GtkWidget*, gpointer)
{
	whichPressed = IDCANCEL;
	gtk_main_quit();
}


CVermDlg::CVermDlg(const char* szTitle, int style)
{
	whichPressed = 0;
	m_style = style;
	m_pDialog = gtk_dialog_new();
	gtk_signal_connect(GTK_OBJECT(m_pDialog), "destroy",
					   GTK_SIGNAL_FUNC(DlgDestroy), NULL);
	gtk_window_set_title(GTK_WINDOW(m_pDialog), szTitle);
	gtk_container_border_width(GTK_CONTAINER(m_pDialog), 5);

	gtk_window_position(GTK_WINDOW(m_pDialog), GTK_WIN_POS_CENTER);

	gtk_box_set_homogeneous(GTK_BOX(GTK_DIALOG(m_pDialog)->action_area), FALSE);
	gtk_box_set_spacing(GTK_BOX(GTK_DIALOG(m_pDialog)->action_area), 10);

	GtkWidget* yes;
	GtkWidget* yestoall;
	GtkWidget* no;
	GtkWidget* notoall;
	GtkWidget* cancel;
	
	GtkWidget* hbuttonbox1 = gtk_hbutton_box_new ();
	gtk_widget_show (hbuttonbox1);
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG(m_pDialog)->action_area), hbuttonbox1, TRUE, TRUE, 0);
	
	if (m_style & MB_OK)
	{
		ok = gtk_button_new_with_label("OK");
		gtk_signal_connect(GTK_OBJECT(ok), "clicked",
						   GTK_SIGNAL_FUNC(ok_clicked), NULL);
		gtk_container_add (GTK_CONTAINER (hbuttonbox1), ok);
		GTK_WIDGET_SET_FLAGS(ok, GTK_CAN_DEFAULT);
		gtk_widget_grab_default(ok);
		gtk_widget_show(ok);
	}
	
	if (m_style & MB_YES)
	{
		yes = gtk_button_new_with_label("Yes");
		gtk_signal_connect(GTK_OBJECT(yes), "clicked",
						   GTK_SIGNAL_FUNC(yes_clicked), NULL);
		gtk_container_add (GTK_CONTAINER (hbuttonbox1), yes);
		GTK_WIDGET_SET_FLAGS(yes, GTK_CAN_DEFAULT);
		gtk_widget_grab_default(yes);
		gtk_widget_show(yes);
	}

	if (m_style & MB_YESTOALL)
	{
		yestoall = gtk_button_new_with_label("Yes To All");
		gtk_signal_connect(GTK_OBJECT(yestoall), "clicked",
						   GTK_SIGNAL_FUNC(yestoall_clicked), NULL);
		gtk_container_add (GTK_CONTAINER (hbuttonbox1), yestoall);
		gtk_widget_show(yestoall);
	}

	if (m_style & MB_NO)
	{
		no = gtk_button_new_with_label("No");
		gtk_signal_connect(GTK_OBJECT(no), "clicked",
						   GTK_SIGNAL_FUNC(no_clicked), NULL);
		gtk_container_add (GTK_CONTAINER (hbuttonbox1), no);
		gtk_widget_show(no);
	}

	if (m_style & MB_NOTOALL)
	{
		notoall = gtk_button_new_with_label("No To All");
		gtk_signal_connect(GTK_OBJECT(notoall), "clicked",
						   GTK_SIGNAL_FUNC(notoall_clicked), NULL);
		gtk_container_add (GTK_CONTAINER (hbuttonbox1), notoall);
		gtk_widget_show(notoall);
	}

	if (m_style & MB_CANCEL)
	{
		cancel = gtk_button_new_with_label("Cancel");
		gtk_signal_connect(GTK_OBJECT(cancel), "clicked",
						   GTK_SIGNAL_FUNC(cancel_clicked), NULL);
		gtk_container_add (GTK_CONTAINER (hbuttonbox1), cancel);
		gtk_widget_show(cancel);
	}
}

void CVermDlg::OnOK(void)
{
	whichPressed = IDOK;
	gtk_main_quit();
}

CVermDlg::~CVermDlg()
{

}

int CVermDlg::DoModal()
{

	gtk_grab_add(GTK_WIDGET(m_pDialog));
	gtk_widget_show(m_pDialog);

	gtk_main();

#if 0
	if (m_style & MB_OK)
		gtk_widget_destroy(ok);
	if (m_style & MB_YES)
		gtk_widget_destroy(yes);
	if (m_style & MB_YESTOALL)
		gtk_widget_destroy(yestoall);
	if (m_style & MB_NO)
		gtk_widget_destroy(no);
	if (m_style & MB_NOTOALL)
		gtk_widget_destroy(notoall);
	if (m_style & MB_CANCEL)
		gtk_widget_destroy(cancel);
#endif
	
	return whichPressed;
}




