/*      Copyright 1998-2002 SourceGear Corporation.
        All Rights Reserved. */

#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <unistd.h>

#include "Vermie.h"
#include "AfxMessageBox.h"

#include "VermProtocolHeader.h"
#include "VermProtocolMessage.h"
#include "VermUtils.h"

#include "VermEdit.h"

int VermViewFile(CVermProtocolMessage* pMessageReceived, FileEdit* pFileEdit)
{
	const char* pszFile = pMessageReceived->GetHeaderValue(HEADER_FILE);
	const char* pszContentLen = pMessageReceived->GetHeaderValue(HEADER_CONTENT_LENGTH);

	if (pMessageReceived->GetHeaderValue(HEADER_ORIGINAL_SIZE))
		pszContentLen = pMessageReceived->GetHeaderValue(HEADER_ORIGINAL_SIZE);

	pFileEdit->bHaveFile = 1;

	if (!pFileEdit->strTmpDir.empty())
	{
		// put the fetched file in the temp directory

		String strFile = pFileEdit->strTmpDir;
		strFile += pszFile;

		// write the file to disk

		int newFile = open(strFile.chars(), O_WRONLY|O_CREAT|O_TRUNC, 0750);

		if (newFile < 0)
		{
			String s("Unable to create temp file for viewing");
			AfxMessageBox(s, MB_OK);
			
			return 1;
		}

		write(newFile, pMessageReceived->m_body, atoi(pszContentLen));

		close(newFile);

		MakeFileReadOnly(strFile);
	}

	char buf[2048];
	
	sprintf(buf, Vermie::m_strViewProgram.chars(), pFileEdit->strFile.chars());

	system(buf);

	return 1;
}

int VermEditFile(String& strFile)
{
	char buf[2048];

	sprintf(buf, Vermie::m_strViewProgram.chars(), strFile.chars());
	
	system(buf);
	
	return 1;
}
