/*      Copyright 1998-2002 SourceGear Corporation.
        All Rights Reserved. */

#ifndef VERMFileView_H
#define VERMFileView_H

#include <gtk/gtk.h>
#include <String.h>

class CVermFrameWnd;
class CVermTreeNode;

class CVermFileView
{
public:
	CVermFileView(CVermFrameWnd* pParent);
	~CVermFileView();
	
public:
	GtkWidget* m_pWidget;
	GtkWidget* m_pList;
	GtkWidget* m_pWorkingDirLabel;
	GtkWidget* m_pProgressLabel;
	GtkWidget* m_pProgressBar;
	GtkWidget* m_pScrolledWin;
	GtkWidget* m_popupMenu;
	
	CVermFrameWnd* m_pParent;
	GtkWidget* m_mView;
	GtkWidget* m_mEdit;
	GtkWidget* m_mShowHistory;
	GtkWidget* m_mGetLatestVersion;
	GtkWidget* m_mCheckOut;
	GtkWidget* m_mCheckIn;
	GtkWidget* m_mUndoCheckout;
	GtkWidget* m_mDelete;
	GtkWidget* m_mLabel;
	GtkWidget* m_mRename;
	GtkWidget* m_mShowDifferences;
	GtkWidget* m_mBranch;

private:
	CVermTreeNode* m_pNodeDisplayed;
	int m_numSelItems;
	int m_bTextOn;

 public:
	void Reset(void);
	void SetFileList(CVermTreeNode* pNode, String& strProject,
					 String& strUsername, String& strWorkingDir,
					 CVermTreeLeaf* pLeaf);
	void UpdateFileInfo(CVermTreeNode* pNode, String& strProject,
						String& strUsername, String& strWorkingDir);
	void SetFileInfo(String& strProject,
					 String& strUsername, String& strWorkingDir,
					 CVermTreeLeaf* pLeaf, int index);
	void SetWorkingDirPane(String&);
	void SetWorkingDirectory(char*);
	
	void ResetStatus(void);
	void SetStatus(double dPercentage);
	void GetFileName(int nIndex, String& strFile);

	void SetWaitState(int);
	void GetColumnWidths(int *columns);
	void RemoveFile(CVermTreeLeaf*);

	void UpdateSharedStatus(CVermTreeLeaf*);
	void UpdatePinStatus(CVermTreeLeaf* pLeaf);
	
 private:
	void ReselectRows(char** rows);
	char** GetSelectedRows(void);	
};
	
	
#endif // VERMFileView_H
