/*      Copyright 1998-2002 SourceGear Corporation.
        All Rights Reserved. */

#include "Vermie.h"
#include "VermFrameWnd.h"
#include "VermMessageView.h"

CVermMessageView::CVermMessageView(CVermFrameWnd* pParent)
{
	m_pParent = pParent;
	m_nLinesToDisplay = Vermie::m_nLinesToDisplay;
	m_nTotalLines = 0;
	
	m_pWidget = gtk_scrolled_window_new(NULL, NULL);

	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(m_pWidget),
								 GTK_POLICY_AUTOMATIC,
								 GTK_POLICY_AUTOMATIC);

//	gtk_widget_set_usize(m_pWidget, Vermie::m_PViewWidth,
//						 Vermie::m_PViewHeight);

	/* Put a text widget in the upper left hand corner. Note the use of
	 * GTK_SHRINK in the y direction */
	m_pText = gtk_text_new (NULL, NULL);
	gtk_widget_set_usize(GTK_WIDGET(m_pText), Vermie::m_MViewWidth,
						 Vermie::m_MViewHeight);
	
	gtk_text_set_word_wrap(GTK_TEXT(m_pText), 0);
	gtk_widget_show (m_pText);

	gtk_container_add(GTK_CONTAINER(m_pWidget), m_pText);
}

CVermMessageView::~CVermMessageView()
{

}

void CVermMessageView::SetLinesToDisplay(int nLines)
{
	m_nLinesToDisplay = nLines;

	if (m_nTotalLines > m_nLinesToDisplay)
		TrimLines();
}

void CVermMessageView::AddMessage(String& message)
{
	gtk_text_insert(GTK_TEXT(m_pText), NULL, NULL, NULL, message.chars(), -1);
	gtk_text_insert(GTK_TEXT(m_pText), NULL, NULL, NULL, "\n", 1);

	++m_nTotalLines;

	if (m_nTotalLines > m_nLinesToDisplay)
	{
		TrimLines();
	}
}

void CVermMessageView::TrimLines(void)
{
	if (m_nTotalLines < m_nLinesToDisplay)
		return;

	int linesToDelete = m_nTotalLines - m_nLinesToDisplay;

	int i = 0;

	char* text = gtk_editable_get_chars(GTK_EDITABLE(m_pText), 0, -1);

	int charPos = 0;
	int numChars = strlen(text);
	
	while (charPos < numChars && i < linesToDelete)
	{
		if (text[charPos++] == '\n')
			++i;
	}

	if (charPos > numChars)
		charPos = numChars;
	
	gtk_text_freeze(GTK_TEXT(m_pText));
	gtk_text_set_point(GTK_TEXT(m_pText), charPos);
	gtk_text_backward_delete(GTK_TEXT(m_pText), charPos);
	gtk_text_set_point(GTK_TEXT(m_pText), numChars - charPos);
	gtk_text_thaw(GTK_TEXT(m_pText));
	
	m_nTotalLines = m_nLinesToDisplay;
}
