/*      Copyright 1998-2002 SourceGear Corporation.
        All Rights Reserved. */

#ifndef VERMPROJECTVIEW_H
#define VERMPROJECTVIEW_H

#include <gtk/gtk.h>

#define FILE_EXTENSION	".sos"
#define SERVER_DIRECTORY_NAME "servers"
#define SOS_FILE_NAME "database"

class CVermFrameWnd;
class String;
class CVermProtocolMessage;

class CVermProjectView
{
public:
	CVermProjectView(CVermFrameWnd* pParent);
	~CVermProjectView();
	
public:
	GtkWidget* m_pWidget;
	GtkWidget* m_pTree;
	GtkWidget* m_popupMenu;
	
	CVermFrameWnd* m_pParent;
	GtkWidget* m_hCurSelItem;
	GtkWidget* m_pCloak;
	int        m_bWaitState;
	
 public:
	void Reset(void);
//	void SaveToFile(String& strServer, String& strDatabase);
//	char* LoadFromFile(String& strServer, String& strDatabase);
	void SetOpenProject(char* pProject);
	void SetWaitState(int bState);
	void SetProjectTree(char* pMessageBody, int nBodySize);

//	String GetWorkingDirectory(GtkWidget* hItem);

//	GtkWidget* GetItemFromProject(const char* pszProject);
	void UpdateProjectTree(char* pBody, GtkWidget* hItem, int* pos, int maxPos);	
	void PruneTree(GtkWidget* hNode);
//	char* GetItemText(GtkWidget* hItem);
	int GetPathFromItem(GtkWidget* hItem, String& path);
	int GetPathSelectedObject(String& path);
	GtkWidget* GetRootItem(void);
	int IsEmpty(void);

	void OnSelChanged(void);
	void OnFocus(void);
	
	void SetFileList(CVermProtocolMessage* pMessageReceived,
					 CVermProtocolMessage* pMessageSent);
	void SetWorkingDirectory(String& strDir);
	CVermTreeNode* GetNodeFromProject(const char* pszProject);	
	int SetFile(CVermProtocolMessage* pMessageReceived,
				CVermProtocolMessage* pMessageSent,	int bAskUserToOverwrite, int& writeState, int bMakeWritable);
	void AddNewProject(GtkWidget* hParentItem, String& strNewProject);
	
private:
	void BuildNewWorkingDirectory(String& strProject, String& strWorkingDir);
	GtkWidget* CreateProject(String& strProject);
	
	CVermTreeLeaf* ParseFileInfo(char** pMessageBody, int nBodySize,
								 int* nCharsRead);

	void DeleteAllNodeInformation(GtkWidget* hItem);
};
	
	
#endif // VERMPROJECTVIEW_H
