/*      Copyright 1998-2002 SourceGear Corporation.
        All Rights Reserved. */

#ifndef VERMPROTOCOLHEADER_H
#define VERMPROTOCOLHEADER_H

#include <String.h>

#define HEADER_DATABASE				  "Database"
#define HEADER_USERNAME				  "Username"
#define HEADER_PASSWORD				  "Password"
#define HEADER_PROTOCOL_VERSION		  "Protocol-Version"
#define HEADER_MESSAGE_ID			  "Message-ID"
#define HEADER_RESPONSE_TO			  "Response-To"
#define HEADER_CONTENT_LENGTH		  "Content-Length"
#define HEADER_PROJECT				  "Project"
#define HEADER_FILE					  "File"
#define HEADER_VERSION				  "Version"
#define HEADER_LABEL				  "Label"
#define HEADER_LOG					  "Log"
#define HEADER_RECURSIVE			  "Recursive"
#define HEADER_DATE					  "Date"
#define HEADER_LOCKED_BY			  "Locked-By"
#define HEADER_LOCKED_PROJECT         "Locked-Project"
#define HEADER_CLIENT_COOKIE		  "Client-Cookie"
#define HEADER_PERMANENT			  "Permanent"
#define HEADER_NAME					  "Name"
#define HEADER_USE_COMPRESSION        "Use-Compression"
#define HEADER_ORIGINAL_SIZE		  "Original-Size"
#define HEADER_DAYS_LEFT			  "Days-Left"
#define HEADER_KEEP_CHECKED_OUT		  "Keep-Checked-Out"
#define HEADER_UNIX_EOL_MARKER        "Unix-EOL-Marker"
#define HEADER_MAC_EOL_MARKER         "Mac-EOL-Marker"
#define HEADER_SHARE_PROJECT          "Share-Project"
#define HEADER_SEND_CHECKSUM          "Send-Checksum"
#define HEADER_SEND_CHECKOUT_PROJECT  "Send-Checkout-Project"
#define HEADER_SEND_PIN_STATUS        "Send-Pin-Status"
#define HEADER_PIN_STATUS			  "Pin-Status"
#define HEADER_SUPPORT_PIN_STATUS     "Support-Pin-Status"
#define HEADER_SEND_ACTION            "Send-Action"
#define HEADER_ERROR_ID               "Error-ID"
#define HEADER_FROM_DATE              "From-Date"
#define HEADER_TO_DATE                "To-Date"
#define HEADER_IGNORE_FILES           "Ignore-Files"
#define HEADER_DEPLOY_DIR			  "Deploy-Directory"
#define HEADER_READONLY				  "Read-only"
#define HEADER_VSS6_BUILD             "VSS6 Build"
#define HEADER_SEARCH_STRING		  "Search String"
// Send File On Merge Fail
#define HEADER_SFOMF                  "SFOMF"
#define HEADER_DATABASE_ALIASES		  "Database Aliases"
#define HEADER_SEND_SHARE_INFO        "Send Share Info"
#define HEADER_SEND_LABEL_COMMENT	  "Send Label Comment"
#define HEADER_KEY_LENGTH		      "Key Length"
#define HEADER_NEW_PROJECT_NAME       "New Project Name"
#define HEADER_BRANCH_AFTER_SHARE     "Branch After Share"

#define ERROR_ID_USER_NOT_FOUND       "421"

class CVermProtocolHeader
{
public:
	String m_name;
	String m_value;

public:
	CVermProtocolHeader();
	CVermProtocolHeader(const char* pName, const char* pValue);
	CVermProtocolHeader(const char* pName, const String& pValue);
	CVermProtocolHeader(String& pName, const String& pValue);

	virtual ~CVermProtocolHeader();
};

#endif /* VERMPROTOCOLHEADER_H */
