/*      Copyright 1998-2002 SourceGear Corporation.
        All Rights Reserved. */

#include <stdio.h>
#include <string.h>

#include "Vermie.h"
#include "VermProtocolHeader.h"
#include "VermProtocolMessage.h"

VermHeaderList::VermHeaderList()
{
	m_pHead = NULL;
	m_pTail = NULL;
}

VermHeaderList::~VermHeaderList()
{
	VermHeader* pTmp = m_pHead;

	while (pTmp != NULL)
	{
		VermHeader* pCur = pTmp;
		
		pTmp = pTmp->m_pNext;

		delete pCur;
	}
}

void VermHeaderList::AddTail(CVermProtocolHeader* pHeader)
{
	if (!m_pHead)
	{
		m_pHead = new VermHeader;
		m_pTail = m_pHead;
	}
	else
	{
		m_pTail->m_pNext = new VermHeader;
		m_pTail = m_pTail->m_pNext;
	}

	m_pTail->m_pHeader = pHeader;
}

CVermProtocolMessage::CVermProtocolMessage()
{
	m_body = NULL;
	m_bodyIndex = 0;
	m_bodySize = 0;
	m_pHeaders = new VermHeaderList();
}

CVermProtocolMessage::~CVermProtocolMessage()
{
	delete m_pHeaders;

	if (m_body)
		delete []m_body;
}

void CVermProtocolMessage::AddHeader(CVermProtocolHeader* pHeader)
{
	if (pHeader)
		m_pHeaders->AddTail(pHeader);
}

const char* CVermProtocolMessage::GetHeaderValue(const char* pszName)
{
	VermHeader* pTmp = m_pHeaders->m_pHead;

	while (pTmp != NULL)
	{
		if (!strcmp(pTmp->m_pHeader->m_name.chars(), pszName))
			return pTmp->m_pHeader->m_value.chars();

		pTmp = pTmp->m_pNext;
	}

	return NULL;
}

void CVermProtocolMessage::AppendHeadersToString(String& str)
{
	if (!m_pHeaders->m_pHead)
		return;

	VermHeader* pTmp = m_pHeaders->m_pHead;

	while (pTmp)
	{
		str += pTmp->m_pHeader->m_name;
		str += ":";
		str += pTmp->m_pHeader->m_value;
		str += "\r\n";

		pTmp = pTmp->m_pNext;
	}
}
