/*      Copyright 1998-2002 SourceGear Corporation.
        All Rights Reserved. */

#include "Vermie.h"
#include "VermTreeLeaf.h"

CVermTreeLeaf::CVermTreeLeaf()
{
	m_name = "";
	m_userLocked = "";
	m_projectLocked = "";
	
	m_nRemoteVersionNumber = -1;
	m_pRemoteVersionDate = 0;

	m_nLocalVersionNumber = -1;
	m_pLocalVersionDate = 0;

	m_nPinnedVersion = -1;
	
	m_bChecked = 0;
	m_bShared = 0;
}

CVermTreeLeaf::CVermTreeLeaf(CVermTreeLeaf* pTreeLeaf)
{
	m_name = pTreeLeaf->m_name;
	m_userLocked = pTreeLeaf->m_userLocked;
	m_projectLocked = pTreeLeaf->m_projectLocked;
	
	m_nRemoteVersionNumber = pTreeLeaf->m_nRemoteVersionNumber;

	if (pTreeLeaf->m_pRemoteVersionDate)
		m_pRemoteVersionDate = pTreeLeaf->m_pRemoteVersionDate;
	else
		m_pRemoteVersionDate = -1;

	m_nLocalVersionNumber = pTreeLeaf->m_nLocalVersionNumber;

	if (pTreeLeaf->m_pLocalVersionDate)
		m_pLocalVersionDate = pTreeLeaf->m_pLocalVersionDate;
	else
		m_pLocalVersionDate = -1;

	m_bChecked = pTreeLeaf->m_bChecked;

	m_bShared = pTreeLeaf->m_bShared;

	m_nPinnedVersion = pTreeLeaf->m_nPinnedVersion;
}

CVermTreeLeaf::~CVermTreeLeaf()
{
}
