/*      Copyright 1998-2002 SourceGear Corporation.
        All Rights Reserved. */


#ifndef VERMTREENODE_H
#define VERMTREENODE_H

#include <String.h>

class CVermTreeLeaf;


typedef struct _VermTreeListNode
{
	CVermTreeLeaf* m_pLeaf;
	struct _VermTreeListNode *m_pNext;
}VermTreeListNode;

class CVermTreeLeafList
{
public:
	VermTreeListNode* m_pHead;
	VermTreeListNode* m_pTail;

	CVermTreeLeafList();
	~CVermTreeLeafList();

	void AddTail(CVermTreeLeaf* pLeaf);
	void DeleteLeaf(CVermTreeLeaf* pLeaf);
};

class CVermTreeNode
{
public:
	short m_bVisited;
	short m_bWebDeploy;
	short m_bCloaked;
	
	String m_strWorkingDir;
	String m_strDeployDir;
	
	CVermTreeLeafList* m_pLeafs;
	
	int m_bChecked;  // This is used when we get a project tree update from
					  // the server to determine if the project still exists

public:
	CVermTreeNode();
	CVermTreeNode(CVermTreeNode* pTreeNode);
	~CVermTreeNode();

	CVermTreeLeaf* GetLeafByName(String& pName);

	void AddLeaf(CVermTreeLeaf* pLeaf);
	void DeleteLeaf(CVermTreeLeaf* pLeaf);
	void DeleteMissingLeaves(void);
	void DeleteLeafInformation(void);
};

#endif /* VERMTREENODE_H */
