/*      Copyright 1998-2002 SourceGear Corporation.
        All Rights Reserved. */

#ifndef VERMIE_H
#define VERMIE_H

#define __extension__

#ifdef MSS
#include "mss.h"
#endif

#include <gtk/gtk.h>

#include "String.h"

#define WINDOWS_EOL "Windows EOL (\\r\\n)"
#define UNIX_EOL    "Unix EOL (\\n)"
#define MAC_EOL     "Mac EOL (\\r)"

typedef struct _Databases
{
	String strAlias;
	String strDatabase;
} Databases;

typedef struct _TimeStamps
{
        long startClock;
        long startTime;

        long challengeClock;
        long challengeTime;

        long seedClock;
        long seedTime;
} TimeStamps;

class Vermie
{
 public:
	static GdkPixmap* m_pShared;
	static GdkBitmap* m_pSharedMask;
	static GdkPixmap* m_pPin;
	static GdkBitmap* m_pPinMask;
	
	static GtkStyle* m_pCloakedStyle;
	static GtkStyle* m_pWebDeployStyle;
	static GtkStyle* m_pCloakedDeployStyle;
	static GtkStyle* m_pNormalStyle;
	
	static GdkColor m_CloakedColor;
	static GdkColor m_DeployColor;
	static GdkColor m_CloakedDeployColor;
	
	static int m_nWidth;
	static int m_nHeight;

	static int m_bPinAvailable;
	
	static short m_bDisplayPinStatus;
	static short m_bUseCompression;
	static short m_bCanUseCompression;
	static short m_bUpdateFileList;
	static short m_bSendKeepAlive;
	static short m_bRemoveLocalCopy;
	static short m_bDontFetchFileOnCheckout;
	static short m_bAlwaysKeepFilesCheckedOut;
	static short m_bRecurseOnProjects;
	static short m_bDontFetchFileOnUndoCheckout;
	static short m_bMakeFilesReadOnly;
	static short m_bUseHTTPProxy;
	static short m_bUseVSS6Features;
	static short m_bShowShareIcon;
	static short m_bUseChecksums;

	// command dialogs
	static short m_bProjectGetLatestVersion;
	static short m_bProjectCheckout;
	static short m_bProjectUndoCheckout;
	static short m_bProjectDeploy;

	static short m_bFileGetLatestVersion;
	static short m_bFileCheckout;
	static short m_bFileUndoCheckout;
	static short m_bFileEditAndView;

	static TimeStamps m_timeStamps;

	static String  m_strServerList;
	static String  m_strPortList;
	static String  m_strLastServer;
	static String  m_strLastPort;
	static String  m_strUserName;
	static String  m_strProxyName;
	static String  m_strPrefsDir;
	static String  m_strDatabaseName;
	static String  m_strDiffProgram;
	static String  m_strProjectDiffProgram;
	static String  m_strViewProgram;
	static String  m_strMergeProgram;
	static String  m_strTimeToRefresh;
	static String  m_strTimeToKeepAlive;
	static String  m_strFileDoubleClick;
	static String  m_strFileEOL;
	
	static int     m_nServersToKeep;
	
	static int     m_ProxyPort;
	static int     m_nSortColumn;
	static int     m_nColumnWidths[5];
	static int     m_nLinesToDisplay;
	
	static int     m_PViewWidth;
	static int     m_PViewHeight;
	static int     m_FViewWidth;
	static int     m_FViewHeight;
	static int     m_MViewWidth;
	static int     m_MViewHeight;
};

#endif // VERMIE_H
